#!/usr/local/bin/python


from obitools.fasta import fastaIterator,formatFasta
from obitools.utils.bioseq import uniqSequence
from obitools.options import getOptionManager
from obitools.options.taxonomyfilter import addTaxonomyDBOptions
from obitools.options.taxonomyfilter import loadTaxonomyDatabase

def addUniqOptions(optionManager):
    optionManager.add_option('-m','--merge',
                             action="append", dest="merge",
                             metavar="<TAG NAME>",
                             type="string",
                             default=[],
                             help="ecoPCR taxonomy Database "
                                  "name")
    

if __name__=='__main__':
#    try:
#        import psyco
#        psyco.full()
#    except ImportError:
#        pass

#    root.setLevel(DEBUG)

    optionParser = getOptionManager([addUniqOptions,addTaxonomyDBOptions],
                                    entryIterator=fastaIterator
                                    )
    
    (options, entries) = optionParser()

    taxonomy=loadTaxonomyDatabase(options)

    uniqSeq=uniqSequence(entries,taxonomy,options.merge)
 
    for seq in uniqSeq:         
        print formatFasta(seq) 
